#pragma once

namespace ReWindow
{

    enum class DeviceType {
        MOUSE, KEYBOARD, GAMEPAD, TOUCHSCREEN, REMOTE, VRHEADSET
    };

    enum class DeviceState {
        OK, LOW_BATTERY, UNAVAILABLE
    };

    class InputDeviceImpl { };
    class InputDeviceImplLinux { };

    class InputDevice {
    public:
        virtual void Update(double elapsed){}

        /// Returns the device's index among devices of the same type.
        uint GetIndex() const;

        virtual DeviceType GetType() const = 0;
        DeviceState GetDeviceState() const;
        bool IsAnyButtonDown();
    };

    struct InputEvent
    {
        std::chrono::system_clock::time_point Timestamp;
    };

    struct BinaryActuatorState
    {
        double TimeHeld;
        bool Pressed;
    };
}